unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  FILECTRL; // to be added for function SelectDirectory

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ SelectDirectory brings up a dialog box to allow the user to select or enter
 a directory name ("folder"). There are two possible syntaxes:

 1. SelectDirectory(Title, RootDir, DirSelected)
 This function displays the standard Windows "Browse for Folder" dialog.
 Parameters:
   Title: the title that should appear above the directory tree.
   RootDir: the directory to be used as the root of the directory tree.
   DirSelected: receives the directory that was selected by the user.
 Return of the function:
  TRUE if the user selected a directory,
  FALSE if the user did not select a directory.
}
procedure TForm1.Button1Click(Sender: TObject);
var
  DirSelected: string;
begin
  if SelectDirectory('Select a folder:', 'C:\Windows', DirSelected) then
    Label1.Caption := 'You selected: ' + DirSelected
  else
    Label1.Caption := 'You did not select a folder';
end;

{ 2. SelectDirectory(Dir, Options, HelpCtx)
  With this form of the syntax, you can show an additional edit-box where the
  user can enter a directory name, even a directory that doesn't exist.
  Parameters:
    Dir: the starting directory. If a directory was selected, this is found in
    this same variable.

    Options: a set of values (between square brackets and separated by commas).
    If Options is empty, no additional edit-box is showed. The user can only
    select an already existing directory (as in syntax 1).
    Options may also contain a combination of the following values:
    - sdAllowCreate: an edit box appears where the user can enter a
    directory name, even one that doesn't yet.
    Attention: this option alone does not create a new directory, but your next code
    can use the value Dir parameter to create the directory.
    - sdPerformCreate: if the user enters a directory name that does not exist,
    SelectDirectory creates it. Of course, this is only meaningful when Options
    contains also sdAllowCreate.
    - sdPrompt:	 displays a message box that informs the user when the entered
    directory does not exist and asks if the directory should be created.
    If the user chooses OK, the directory is created if Options also contains
    sdPerformCreate.
    Attention: if Options does not contain sdPerformCreate, the new directory is
    not created automatically: your next code should create it!
    sdPrompt is only meaningful when Options contains sdAllowCreate.

    HelpCtx: the help context ID number (not used in our example).
 Return of the function: the same as syntax 1: TRUE if a directory was selected,
  otherwise FALSE.
}
procedure TForm1.Button2Click(Sender: TObject);
var
  Dir: string;
begin
  Dir := 'C:\Program Files';
  if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt], 0) then
    Label1.Caption := 'You selected: ' + Dir
  else
    Label1.Caption := 'You did not select a folder';
end;

end.
